# coding: utf-8

from __future__ import absolute_import

from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from privacy_metrics import util
from privacy_metrics.models.base_model_ import Model


class ProvidedInformation(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(
        self,
        owner: str = None,
        category: str = None,
        consent_withdraw: str = None,
        country: str = None,
        data_controller: str = None,
        data_controller_contact_address: str = None,
        data_controller_contact_mail: str = None,
        data_controller_contact_phone: str = None,
        data_controller_identity: str = None,
        data_for_automatic_decision: str = None,
        data_location: str = None,
        data_processed: str = None,
        data_processing_legal_basis: str = None,
        data_processing_purposes: List[str] = None,
        data_processor: str = None,
        data_recipients: List[str] = None,
        data_retention_period: str = None,
        data_subprocessors: List[str] = None,
        data_transfer: str = None,
        declared_company_name: str = None,
        dpo_contact_address: str = None,
        dpo_contact_mail: str = None,
        dpo_contact_phone: str = None,
        user_rights: str = None,
        website: str = None,
    ):  # noqa: E501
        """ProvidedInformation - a model defined in Swagger

        :param owner: The owner of this ProvidedInformation.  # noqa: E501
        :type owner: str
        :param category: The category of this ProvidedInformation.  # noqa: E501
        :type category: str
        :param consent_withdraw: The consent_withdraw of this ProvidedInformation.  # noqa: E501
        :type consent_withdraw: str
        :param country: The country of this ProvidedInformation.  # noqa: E501
        :type country: str
        :param data_controller: The data_controller of this ProvidedInformation.  # noqa: E501
        :type data_controller: str
        :param data_controller_contact_address: The data_controller_contact_address of this ProvidedInformation.  # noqa: E501
        :type data_controller_contact_address: str
        :param data_controller_contact_mail: The data_controller_contact_mail of this ProvidedInformation.  # noqa: E501
        :type data_controller_contact_mail: str
        :param data_controller_contact_phone: The data_controller_contact_phone of this ProvidedInformation.  # noqa: E501
        :type data_controller_contact_phone: str
        :param data_controller_identity: The data_controller_identity of this ProvidedInformation.  # noqa: E501
        :type data_controller_identity: str
        :param data_for_automatic_decision: The data_for_automatic_decision of this ProvidedInformation.  # noqa: E501
        :type data_for_automatic_decision: str
        :param data_location: The data_location of this ProvidedInformation.  # noqa: E501
        :type data_location: str
        :param data_processed: The data_processed of this ProvidedInformation.  # noqa: E501
        :type data_processed: str
        :param data_processing_legal_basis: The data_processing_legal_basis of this ProvidedInformation.  # noqa: E501
        :type data_processing_legal_basis: str
        :param data_processing_purposes: The data_processing_purposes of this ProvidedInformation.  # noqa: E501
        :type data_processing_purposes: List[str]
        :param data_processor: The data_processor of this ProvidedInformation.  # noqa: E501
        :type data_processor: str
        :param data_recipients: The data_recipients of this ProvidedInformation.  # noqa: E501
        :type data_recipients: List[str]
        :param data_retention_period: The data_retention_period of this ProvidedInformation.  # noqa: E501
        :type data_retention_period: str
        :param data_subprocessors: The data_subprocessors of this ProvidedInformation.  # noqa: E501
        :type data_subprocessors: List[str]
        :param data_transfer: The data_transfer of this ProvidedInformation.  # noqa: E501
        :type data_transfer: str
        :param declared_company_name: The declared_company_name of this ProvidedInformation.  # noqa: E501
        :type declared_company_name: str
        :param dpo_contact_address: The dpo_contact_address of this ProvidedInformation.  # noqa: E501
        :type dpo_contact_address: str
        :param dpo_contact_mail: The dpo_contact_mail of this ProvidedInformation.  # noqa: E501
        :type dpo_contact_mail: str
        :param dpo_contact_phone: The dpo_contact_phone of this ProvidedInformation.  # noqa: E501
        :type dpo_contact_phone: str
        :param user_rights: The user_rights of this ProvidedInformation.  # noqa: E501
        :type user_rights: str
        :param website: The website of this ProvidedInformation.  # noqa: E501
        :type website: str
        """
        self.swagger_types = {
            "owner": str,
            "category": str,
            "consent_withdraw": str,
            "country": str,
            "data_controller": str,
            "data_controller_contact_address": str,
            "data_controller_contact_mail": str,
            "data_controller_contact_phone": str,
            "data_controller_identity": str,
            "data_for_automatic_decision": str,
            "data_location": str,
            "data_processed": str,
            "data_processing_legal_basis": str,
            "data_processing_purposes": List[str],
            "data_processor": str,
            "data_recipients": List[str],
            "data_retention_period": str,
            "data_subprocessors": List[str],
            "data_transfer": str,
            "declared_company_name": str,
            "dpo_contact_address": str,
            "dpo_contact_mail": str,
            "dpo_contact_phone": str,
            "user_rights": str,
            "website": str,
        }

        self.attribute_map = {
            "owner": "owner",
            "category": "category",
            "consent_withdraw": "consent_withdraw",
            "country": "country",
            "data_controller": "data_controller",
            "data_controller_contact_address": "data_controller_contact_address",
            "data_controller_contact_mail": "data_controller_contact_mail",
            "data_controller_contact_phone": "data_controller_contact_phone",
            "data_controller_identity": "data_controller_identity",
            "data_for_automatic_decision": "data_for_automatic_decision",
            "data_location": "data_location",
            "data_processed": "data_processed",
            "data_processing_legal_basis": "data_processing_legal_basis",
            "data_processing_purposes": "data_processing_purposes",
            "data_processor": "data_processor",
            "data_recipients": "data_recipients",
            "data_retention_period": "data_retention_period",
            "data_subprocessors": "data_subprocessors",
            "data_transfer": "data_transfer",
            "declared_company_name": "declared_company_name",
            "dpo_contact_address": "dpo_contact_address",
            "dpo_contact_mail": "dpo_contact_mail",
            "dpo_contact_phone": "dpo_contact_phone",
            "user_rights": "user_rights",
            "website": "website",
        }
        self._owner = owner
        self._category = category
        self._consent_withdraw = consent_withdraw
        self._country = country
        self._data_controller = data_controller
        self._data_controller_contact_address = data_controller_contact_address
        self._data_controller_contact_mail = data_controller_contact_mail
        self._data_controller_contact_phone = data_controller_contact_phone
        self._data_controller_identity = data_controller_identity
        self._data_for_automatic_decision = data_for_automatic_decision
        self._data_location = data_location
        self._data_processed = data_processed
        self._data_processing_legal_basis = data_processing_legal_basis
        self._data_processing_purposes = data_processing_purposes
        self._data_processor = data_processor
        self._data_recipients = data_recipients
        self._data_retention_period = data_retention_period
        self._data_subprocessors = data_subprocessors
        self._data_transfer = data_transfer
        self._declared_company_name = declared_company_name
        self._dpo_contact_address = dpo_contact_address
        self._dpo_contact_mail = dpo_contact_mail
        self._dpo_contact_phone = dpo_contact_phone
        self._user_rights = user_rights
        self._website = website

    @classmethod
    def from_dict(cls, dikt) -> "ProvidedInformation":
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ProvidedInformation of this ProvidedInformation.  # noqa: E501
        :rtype: ProvidedInformation
        """
        return util.deserialize_model(dikt, cls)

    @property
    def owner(self) -> str:
        """Gets the owner of this ProvidedInformation.


        :return: The owner of this ProvidedInformation.
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner: str):
        """Sets the owner of this ProvidedInformation.


        :param owner: The owner of this ProvidedInformation.
        :type owner: str
        """
        if owner is None:
            raise ValueError(
                "Invalid value for `owner`, must not be `None`"
            )  # noqa: E501

        self._owner = owner

    @property
    def category(self) -> str:
        """Gets the category of this ProvidedInformation.


        :return: The category of this ProvidedInformation.
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category: str):
        """Sets the category of this ProvidedInformation.


        :param category: The category of this ProvidedInformation.
        :type category: str
        """
        if category is None:
            raise ValueError(
                "Invalid value for `category`, must not be `None`"
            )  # noqa: E501

        self._category = category

    @property
    def consent_withdraw(self) -> str:
        """Gets the consent_withdraw of this ProvidedInformation.


        :return: The consent_withdraw of this ProvidedInformation.
        :rtype: str
        """
        return self._consent_withdraw

    @consent_withdraw.setter
    def consent_withdraw(self, consent_withdraw: str):
        """Sets the consent_withdraw of this ProvidedInformation.


        :param consent_withdraw: The consent_withdraw of this ProvidedInformation.
        :type consent_withdraw: str
        """

        self._consent_withdraw = consent_withdraw

    @property
    def country(self) -> str:
        """Gets the country of this ProvidedInformation.


        :return: The country of this ProvidedInformation.
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country: str):
        """Sets the country of this ProvidedInformation.


        :param country: The country of this ProvidedInformation.
        :type country: str
        """
        if country is None:
            raise ValueError(
                "Invalid value for `country`, must not be `None`"
            )  # noqa: E501

        self._country = country

    @property
    def data_controller(self) -> str:
        """Gets the data_controller of this ProvidedInformation.


        :return: The data_controller of this ProvidedInformation.
        :rtype: str
        """
        return self._data_controller

    @data_controller.setter
    def data_controller(self, data_controller: str):
        """Sets the data_controller of this ProvidedInformation.


        :param data_controller: The data_controller of this ProvidedInformation.
        :type data_controller: str
        """
        if data_controller is None:
            raise ValueError(
                "Invalid value for `data_controller`, must not be `None`"
            )  # noqa: E501

        self._data_controller = data_controller

    @property
    def data_controller_contact_address(self) -> str:
        """Gets the data_controller_contact_address of this ProvidedInformation.


        :return: The data_controller_contact_address of this ProvidedInformation.
        :rtype: str
        """
        return self._data_controller_contact_address

    @data_controller_contact_address.setter
    def data_controller_contact_address(self, data_controller_contact_address: str):
        """Sets the data_controller_contact_address of this ProvidedInformation.


        :param data_controller_contact_address: The data_controller_contact_address of this ProvidedInformation.
        :type data_controller_contact_address: str
        """

        self._data_controller_contact_address = data_controller_contact_address

    @property
    def data_controller_contact_mail(self) -> str:
        """Gets the data_controller_contact_mail of this ProvidedInformation.


        :return: The data_controller_contact_mail of this ProvidedInformation.
        :rtype: str
        """
        return self._data_controller_contact_mail

    @data_controller_contact_mail.setter
    def data_controller_contact_mail(self, data_controller_contact_mail: str):
        """Sets the data_controller_contact_mail of this ProvidedInformation.


        :param data_controller_contact_mail: The data_controller_contact_mail of this ProvidedInformation.
        :type data_controller_contact_mail: str
        """

        self._data_controller_contact_mail = data_controller_contact_mail

    @property
    def data_controller_contact_phone(self) -> str:
        """Gets the data_controller_contact_phone of this ProvidedInformation.


        :return: The data_controller_contact_phone of this ProvidedInformation.
        :rtype: str
        """
        return self._data_controller_contact_phone

    @data_controller_contact_phone.setter
    def data_controller_contact_phone(self, data_controller_contact_phone: str):
        """Sets the data_controller_contact_phone of this ProvidedInformation.


        :param data_controller_contact_phone: The data_controller_contact_phone of this ProvidedInformation.
        :type data_controller_contact_phone: str
        """

        self._data_controller_contact_phone = data_controller_contact_phone

    @property
    def data_controller_identity(self) -> str:
        """Gets the data_controller_identity of this ProvidedInformation.


        :return: The data_controller_identity of this ProvidedInformation.
        :rtype: str
        """
        return self._data_controller_identity

    @data_controller_identity.setter
    def data_controller_identity(self, data_controller_identity: str):
        """Sets the data_controller_identity of this ProvidedInformation.


        :param data_controller_identity: The data_controller_identity of this ProvidedInformation.
        :type data_controller_identity: str
        """

        self._data_controller_identity = data_controller_identity

    @property
    def data_for_automatic_decision(self) -> str:
        """Gets the data_for_automatic_decision of this ProvidedInformation.


        :return: The data_for_automatic_decision of this ProvidedInformation.
        :rtype: str
        """
        return self._data_for_automatic_decision

    @data_for_automatic_decision.setter
    def data_for_automatic_decision(self, data_for_automatic_decision: str):
        """Sets the data_for_automatic_decision of this ProvidedInformation.


        :param data_for_automatic_decision: The data_for_automatic_decision of this ProvidedInformation.
        :type data_for_automatic_decision: str
        """

        self._data_for_automatic_decision = data_for_automatic_decision

    @property
    def data_location(self) -> str:
        """Gets the data_location of this ProvidedInformation.


        :return: The data_location of this ProvidedInformation.
        :rtype: str
        """
        return self._data_location

    @data_location.setter
    def data_location(self, data_location: str):
        """Sets the data_location of this ProvidedInformation.


        :param data_location: The data_location of this ProvidedInformation.
        :type data_location: str
        """

        self._data_location = data_location

    @property
    def data_processed(self) -> str:
        """Gets the data_processed of this ProvidedInformation.


        :return: The data_processed of this ProvidedInformation.
        :rtype: str
        """
        return self._data_processed

    @data_processed.setter
    def data_processed(self, data_processed: str):
        """Sets the data_processed of this ProvidedInformation.


        :param data_processed: The data_processed of this ProvidedInformation.
        :type data_processed: str
        """

        self._data_processed = data_processed

    @property
    def data_processing_legal_basis(self) -> str:
        """Gets the data_processing_legal_basis of this ProvidedInformation.


        :return: The data_processing_legal_basis of this ProvidedInformation.
        :rtype: str
        """
        return self._data_processing_legal_basis

    @data_processing_legal_basis.setter
    def data_processing_legal_basis(self, data_processing_legal_basis: str):
        """Sets the data_processing_legal_basis of this ProvidedInformation.


        :param data_processing_legal_basis: The data_processing_legal_basis of this ProvidedInformation.
        :type data_processing_legal_basis: str
        """

        self._data_processing_legal_basis = data_processing_legal_basis

    @property
    def data_processing_purposes(self) -> List[str]:
        """Gets the data_processing_purposes of this ProvidedInformation.


        :return: The data_processing_purposes of this ProvidedInformation.
        :rtype: str
        """
        return self._data_processing_purposes

    @data_processing_purposes.setter
    def data_processing_purposes(self, data_processing_purposes: List[str]):
        """Sets the data_processing_purposes of this ProvidedInformation.


        :param data_processing_purposes: The data_processing_purposes of this ProvidedInformation.
        :type data_processing_purposes: List[str]
        """

        self._data_processing_purposes = data_processing_purposes

    @property
    def data_processor(self) -> str:
        """Gets the data_processor of this ProvidedInformation.


        :return: The data_processor of this ProvidedInformation.
        :rtype: str
        """
        return self._data_processor

    @data_processor.setter
    def data_processor(self, data_processor: str):
        """Sets the data_processor of this ProvidedInformation.


        :param data_processor: The data_processor of this ProvidedInformation.
        :type data_processor: str
        """
        if data_processor is None:
            raise ValueError(
                "Invalid value for `data_processor`, must not be `None`"
            )  # noqa: E501

        self._data_processor = data_processor

    @property
    def data_recipients(self) -> List[str]:
        """Gets the data_recipients of this ProvidedInformation.


        :return: The data_recipients of this ProvidedInformation.
        :rtype: List[str]
        """
        return self._data_recipients

    @data_recipients.setter
    def data_recipients(self, data_recipients: List[str]):
        """Sets the data_recipients of this ProvidedInformation.


        :param data_recipients: The data_recipients of this ProvidedInformation.
        :type data_recipients: List[str]
        """
        if data_recipients is None:
            raise ValueError(
                "Invalid value for `data_recipients`, must not be `None`"
            )  # noqa: E501

        self._data_recipients = data_recipients

    @property
    def data_retention_period(self) -> str:
        """Gets the data_retention_period of this ProvidedInformation.


        :return: The data_retention_period of this ProvidedInformation.
        :rtype: str
        """
        return self._data_retention_period

    @data_retention_period.setter
    def data_retention_period(self, data_retention_period: str):
        """Sets the data_retention_period of this ProvidedInformation.


        :param data_retention_period: The data_retention_period of this ProvidedInformation.
        :type data_retention_period: str
        """
        if data_retention_period is None:
            raise ValueError(
                "Invalid value for `data_retention_period`, must not be `None`"
            )  # noqa: E501

        self._data_retention_period = data_retention_period

    @property
    def data_subprocessors(self) -> List[str]:
        """Gets the data_subprocessors of this ProvidedInformation.


        :return: The data_subprocessors of this ProvidedInformation.
        :rtype: List[str]
        """
        return self._data_subprocessors

    @data_subprocessors.setter
    def data_subprocessors(self, data_subprocessors: List[str]):
        """Sets the data_subprocessors of this ProvidedInformation.


        :param data_subprocessors: The data_subprocessors of this ProvidedInformation.
        :type data_subprocessors: List[str]
        """
        if data_subprocessors is None:
            raise ValueError(
                "Invalid value for `data_subprocessors`, must not be `None`"
            )  # noqa: E501

        self._data_subprocessors = data_subprocessors

    @property
    def data_transfer(self) -> str:
        """Gets the data_transfer of this ProvidedInformation.


        :return: The data_transfer of this ProvidedInformation.
        :rtype: str
        """
        return self._data_transfer

    @data_transfer.setter
    def data_transfer(self, data_transfer: str):
        """Sets the data_transfer of this ProvidedInformation.


        :param data_transfer: The data_transfer of this ProvidedInformation.
        :type data_transfer: str
        """

        self._data_transfer = data_transfer

    @property
    def declared_company_name(self) -> str:
        """Gets the declared_company_name of this ProvidedInformation.


        :return: The declared_company_name of this ProvidedInformation.
        :rtype: str
        """
        return self._declared_company_name

    @declared_company_name.setter
    def declared_company_name(self, declared_company_name: str):
        """Sets the declared_company_name of this ProvidedInformation.


        :param declared_company_name: The declared_company_name of this ProvidedInformation.
        :type declared_company_name: str
        """
        if declared_company_name is None:
            raise ValueError(
                "Invalid value for `declared_company_name`, must not be `None`"
            )  # noqa: E501

        self._declared_company_name = declared_company_name

    @property
    def dpo_contact_address(self) -> str:
        """Gets the dpo_contact_address of this ProvidedInformation.


        :return: The dpo_contact_address of this ProvidedInformation.
        :rtype: str
        """
        return self._dpo_contact_address

    @dpo_contact_address.setter
    def dpo_contact_address(self, dpo_contact_address: str):
        """Sets the dpo_contact_address of this ProvidedInformation.


        :param dpo_contact_address: The dpo_contact_address of this ProvidedInformation.
        :type dpo_contact_address: str
        """

        self._dpo_contact_address = dpo_contact_address

    @property
    def dpo_contact_mail(self) -> str:
        """Gets the dpo_contact_mail of this ProvidedInformation.


        :return: The dpo_contact_mail of this ProvidedInformation.
        :rtype: str
        """
        return self._dpo_contact_mail

    @dpo_contact_mail.setter
    def dpo_contact_mail(self, dpo_contact_mail: str):
        """Sets the dpo_contact_mail of this ProvidedInformation.


        :param dpo_contact_mail: The dpo_contact_mail of this ProvidedInformation.
        :type dpo_contact_mail: str
        """

        self._dpo_contact_mail = dpo_contact_mail

    @property
    def dpo_contact_phone(self) -> str:
        """Gets the dpo_contact_phone of this ProvidedInformation.


        :return: The dpo_contact_phone of this ProvidedInformation.
        :rtype: str
        """
        return self._dpo_contact_phone

    @dpo_contact_phone.setter
    def dpo_contact_phone(self, dpo_contact_phone: str):
        """Sets the dpo_contact_phone of this ProvidedInformation.


        :param dpo_contact_phone: The dpo_contact_phone of this ProvidedInformation.
        :type dpo_contact_phone: str
        """

        self._dpo_contact_phone = dpo_contact_phone

    @property
    def user_rights(self) -> str:
        """Gets the user_rights of this ProvidedInformation.


        :return: The user_rights of this ProvidedInformation.
        :rtype: str
        """
        return self._user_rights

    @user_rights.setter
    def user_rights(self, user_rights: str):
        """Sets the user_rights of this ProvidedInformation.


        :param user_rights: The user_rights of this ProvidedInformation.
        :type user_rights: str
        """

        self._user_rights = user_rights

    @property
    def website(self) -> str:
        """Gets the website of this ProvidedInformation.


        :return: The website of this ProvidedInformation.
        :rtype: str
        """
        return self._website

    @website.setter
    def website(self, website: str):
        """Sets the website of this ProvidedInformation.


        :param website: The website of this ProvidedInformation.
        :type website: str
        """
        if website is None:
            raise ValueError(
                "Invalid value for `website`, must not be `None`"
            )  # noqa: E501

        self._website = website
